depmod.sh 1.67 KB
Newer Older
1 2 3 4
#!/bin/sh
#
# A depmod wrapper used by the toplevel Makefile

5 6
if test $# -ne 3; then
	echo "Usage: $0 /sbin/depmod <kernelrelease> <symbolprefix>" >&2
7 8 9 10
	exit 1
fi
DEPMOD=$1
KERNELRELEASE=$2
11
SYMBOL_PREFIX=$3
12 13 14 15

if ! test -r System.map -a -x "$DEPMOD"; then
	exit 0
fi
16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34

# older versions of depmod don't support -P <symbol-prefix>
# support was added in module-init-tools 3.13
if test -n "$SYMBOL_PREFIX"; then
	release=$("$DEPMOD" --version)
	package=$(echo "$release" | cut -d' ' -f 1)
	if test "$package" = "module-init-tools"; then
		version=$(echo "$release" | cut -d' ' -f 2)
		later=$(printf '%s\n' "$version" "3.13" | sort -V | tail -n 1)
		if test "$later" != "$version"; then
			# module-init-tools < 3.13, drop the symbol prefix
			SYMBOL_PREFIX=""
		fi
	fi
	if test -n "$SYMBOL_PREFIX"; then
		SYMBOL_PREFIX="-P $SYMBOL_PREFIX"
	fi
fi

35 36 37
# older versions of depmod require the version string to start with three
# numbers, so we cheat with a symlink here
depmod_hack_needed=true
38 39 40 41 42
tmp_dir=$(mktemp -d ${TMPDIR:-/tmp}/depmod.XXXXXX)
mkdir -p "$tmp_dir/lib/modules/$KERNELRELEASE"
if "$DEPMOD" -b "$tmp_dir" $KERNELRELEASE 2>/dev/null; then
	if test -e "$tmp_dir/lib/modules/$KERNELRELEASE/modules.dep" -o \
		-e "$tmp_dir/lib/modules/$KERNELRELEASE/modules.dep.bin"; then
43 44 45
		depmod_hack_needed=false
	fi
fi
46
rm -rf "$tmp_dir"
47 48 49 50 51 52
if $depmod_hack_needed; then
	symlink="$INSTALL_MOD_PATH/lib/modules/99.98.$KERNELRELEASE"
	ln -s "$KERNELRELEASE" "$symlink"
	KERNELRELEASE=99.98.$KERNELRELEASE
fi

53 54 55 56
set -- -ae -F System.map
if test -n "$INSTALL_MOD_PATH"; then
	set -- "$@" -b "$INSTALL_MOD_PATH"
fi
57
"$DEPMOD" "$@" "$KERNELRELEASE" $SYMBOL_PREFIX
58 59 60 61 62 63 64
ret=$?

if $depmod_hack_needed; then
	rm -f "$symlink"
fi

exit $ret